var Gametod = function() {
	
	this.initialize = function() {
		var self = this;
		this.el = $('<div/>');
		todplayers.length = 0;
		$.jStorage.deleteKey("latestplayer");
		self.registerEvents();
	},
	
	this.render = function() {
		this.el.html(gametodhtml);
        return this;
	},

	this.registerEvents = function() {
		var self = this;
		var rounds = 10;
		var evil = 0;
		this.el.on("click", "#nexttod", function() {
			if (entodplayers.length > 0) {
				$('.todcontentwrapper').html(todsettings2);
			}
			else {
				app.showAlert("You need to add players!")
			}
		});
		this.el.on("click", "#starttod", function() {
			$.jStorage.set("evil", evil);
			self.newGame(rounds);
		});
		this.el.on("click", ".endround", function() {
			var round = $.jStorage.get("round");
			var rounds = $.jStorage.get("rounds");
			round++;
			if (round == rounds) {
				self.endGame();
			} else {
				self.waitStart();
			}
		});
		this.el.on("click", ".todaddplayer", function() {
			var player = $('.todplayers').val();
			if (player.length > 0) {
				entodplayers.push({ player: player });
				$('.todplaying').append("<li class=\"teamslist\"><small>" + player + "</small></li>")
				$('.todplayers').val("");
				$('.todplayers').attr("placeholder", "Add another player..");
			} else {
				app.showAlert("You need to type a name first!");
			}
		});
		this.el.on("keypress", ".todplayers", function(event) {
        	var player = $('.todplayers').val();
        	var p = event.which;
        	if (p == 13) { 
        		event.preventDefault();
        		if (player.length > 0) {
					entodplayers.push({ player: player });
					$('.todplaying').append("<li class=\"teamslist\"><small>" + player + "</small></li>")
					$('.todplayers').val("");
					$('.todplayers').attr("placeholder", "Add another player..");
				} else {
					app.showAlert("You need to type a name first!");
				}
        	}
        	return;
        });
		this.el.on("click", ".cr5", function() {
			rounds = 10;
			$('.selectrounds').text("10");
		});
		this.el.on("click", ".cr10", function() {
			rounds = 20;
			$('.selectrounds').text("20");
		});
		this.el.on("click", ".cr15", function() {
			rounds = 30;
			$('.selectrounds').text("30");
		});
		this.el.on("click", ".cr30", function() {
			rounds = 50;
			$('.selectrounds').text("50");
		});
		this.el.on("click", ".todnice", function() {
			evil = 0;
			$('.selectdifficulty').text("Nice");
		});
		this.el.on("click", ".todevil", function() {
			evil = 1;
			$('.selectdifficulty').text("Evil");
		});
		this.el.on("click", ".todall", function() {
			evil = 2;
			$('.selectdifficulty').text("All");
		});
		self.el.on('click', '#starttruth', function() {
			var dare = false;
			self.startRound(entodplayer, dare);
		});
		self.el.on('click', '#startdare', function() {
			var dare = true;
			self.startRound(entodplayer, dare);
		});
		self.el.on('click', '.playagain', function() {
			self.playAgain();
		});
	},

	this.playAgain = function() {
		var self = this;
		var rounds = $.jStorage.get("rounds");
		clearInterval(countdown);
		self.newGame(rounds);
	}

	this.waitStart = function() {
		var self = this;
		var round = $.jStorage.get("round");
		var rounds = $.jStorage.get("rounds");
		var latestplayer = $.jStorage.get("latestplayer");
		if (round == rounds) {
			self.endGame();
		}
		else {
			round++;
			$.jStorage.set("round", round);
			var playernm = parseFloat(entodplayers.length);
			//console.log(playernm);
			$('.todcontentwrapper').html(todwaitstart);
			var p1 = 1;
			//console.log(latestplayer);
			if (latestplayer >= playernm) {
				//console.log("reset");
				p1 = 1;
				$.jStorage.set("latestplayer", p1);
			}
			else {
				//console.log("add one");
				latestplayer++;
				p1 = latestplayer;
				$.jStorage.set("latestplayer", p1);
			}
			//var p1 = Math.floor(Math.random()*playernm);
			p1--;
			//console.log(p1);
			entodplayer = entodplayers[p1].player;
			//console.log(player);
			$('.playername').append("Next up is <b>" + entodplayer + ".</b> \n Truth or Dare?");
		}

	}

	this.endGame = function() {
		$.jStorage.deleteKey("round");
		app.hasPlayedGame();
		$('.todcontentwrapper').html(todendgame);
	}

	this.startRound = function(entodplayer, dare) {
		var self = this;
		var round = $.jStorage.get("round");
		var rounds = $.jStorage.get("rounds");
		if (round == rounds) {
			self.endGame();
			return;
		} else {
			$('.todcontentwrapper').html(todstartround);
			if (dare) {
				var todtodo = self.getDare();
				$('.todinstructions').html("<b>" + entodplayer + "</b>: <br> " + todtodo);		
			}
			else if (!dare) {
				var todtodo = self.getTruth();
				//console.log(todtodo)
				$('.todinstructions').html("<b>" + entodplayer + "</b>: <br> " + todtodo);	
			}
		}
		return;
	}

	this.newGame = function(rounds) {
		var self = this;
		var rounds = parseFloat(rounds);
		rounds++;
		$.jStorage.set("rounds", rounds);
		$.jStorage.set("round", 0);
		$('#starttod').detach();
		self.populateContent();
		self.waitStart();
	},

	this.getDare = function() {
		var evil = parseFloat($.jStorage.get("evil"));
        if (evil == 0) {
        	var length = nicedare.length;
        	var generatedid = Math.floor(Math.random()*length);
	        var dare = nicedare.splice(generatedid, 1);
	        return dare;
        } else if (evil == 1) {
        	var length = evildare.length;
        	var generatedid = Math.floor(Math.random()*length);
	        var dare = evildare.splice(generatedid, 1);
	        return dare;     	
        } else if (evil == 2) {
        	var length = alldare.length;
        	var generatedid = Math.floor(Math.random()*length);
	        var dare = alldare.splice(generatedid, 1);
	        return dare;
        } else {
        	return;
        }
	},

	this.getTruth = function() {
		var evil = parseFloat($.jStorage.get("evil"));
        if (evil == 0) {
        	var length = nicetruth.length;
      		//console.log(length);
        	var generatedid = Math.floor(Math.random()*length);
        	//console.log(generatedid);
	        var truth = nicetruth.splice(generatedid, 1);
	        return truth;
        } else if (evil == 1) {
      		var length = eviltruth.length;
      		//console.log(length);
        	var generatedid = Math.floor(Math.random()*length);
        	//console.log(generatedid);
	        var truth = eviltruth.splice(generatedid, 1);
	        return truth;   	
        } else if (evil == 2) {
        	var length = alltruth.length;
        	var generatedid = Math.floor(Math.random()*length);
	        var truth = alltruth.splice(generatedid, 1);
	        return truth;
        } else {
        	return;
        }
	},

	this.populateContent = function() {

		eviltruth = ["How did you lose your virginity?","How many people have you had sex with?","What is the funniest place you had sex in?","What is your worst sex memory?","Have you ever watched a porn movie?","What is your favourite sex position?",
					"If you could have sex with anyone in the world, who would you choose?","Have you ever been caught while having sex?",
					"Have you ever cought your parents having sex?","Do you own a sex toy?","Would you be willing to initiate something sexual with someone at your job?",
					"Have you ever done something sexual with someone with the same sex as you?","Have you ever had a sex dream about someone inappropriate?",
					"If you needed to sleep with someone from the Harry Potter cast, who would you choose?","What is the most inappropriate thing you have done while being drunk?",
					"Have you ever been unfaithful to your partner?","When was the first time you were drunk?","Which is the largest age difference between you and someone you've slept with?",
					"Have you ever thought about a friends family in a sexual way?","Do you regret some of your sex partners?","Have you ever slept with someone who was in a relationship at that point?",
					"What is your favourite sex song?","Have you ever slept with someone you think is ugly?"]

		evildare = ["Dance to a song by Miley Cyrus and twerk","Dance to the Gagnam style song","Take of your bra (if you have one on)",
					"Switch clothes with someone of the opposite sex","Spank someone","Send a sexy SMS to someone","Lick one of the other players",
					"Speak in clichés the rest of the evening","Give someone a lapdance","Dance to the song I'm sexy and I know it by LMFAO",
					"Pretend that you are giving birth","Call someone and sing Oops i did it again by Britney Spears","Pretend to be a horny monkey for the next round",
					"Let someone be your horse and take a ride around the room","Give someone a kiss","Do doggy style with someone",
					"Drink up what's left in your glass","Tell your best pick up line and flirt with someone","Put make-up on someone and make them look like a hooker",
					"Choose a person you like and hump against his/her leg like a dog and pretend to have an orgasm","Pretend to have an orgasm",
					"Let someone send a text from your phone to someone of their choice","Do a body shot"]

		nicetruth = ["What was your last dream about?","What is the most embarrassing thing you have done?","Have your ever shop-lifted?",
					"What is the name of your first love?","Who is your role model?","Who would you be if you could be someone for a day?",
					"What would you do if you were invisible for a day?","Which character in Harry Potter would you be and why?",
					"Do you have a celebrity crush? If yes, who?","If you could just use one word for the rest of your life, what would it be?",
					"Do you believe in ghosts?","If you could travel anywhere in the world, where would you go?",
					"What show do you think you would have best chance of winning; Let´s dance, Idol or Masterchef?",
					"If you were a character in a TV-show, who would you be?","Tell a good pick up line",
					"When was the last time you had a blackout?","Tell us about the first time you where drunk",
					"What is the funniest thing you have done while being drunk?",
					"Tell a funny story about someone in the group", "What was your dream job when growing up?","Do you have any phobia?",
					"Do you have any secret talent?","What part of your body are you most satisfied with?",
					"Tell us about the first time you met everyone, first impressions and so on","Do a presentation about the person sitting to your right",
					"What would you wish if you could wish for 3 things?","If you were reborn as an animal, what do you think you would be?",
					"What would your name be if you were a porn star?","Share some good advice","Tell us something unexpected about you",
					"Tell us about your first kiss","Who is the best-looking person that you have kissed?",
					"What is the age of the youngest and the oldest person that you have kissed?","Have you kissed more than one person within 24-hours?",
					"Name one thing that attracts you?","What is the most embarassing disc you own?",
					"Have you ever told a lie to get someone to sleep with you? If yes, what did you say?","Have you been interested of someone with the same sex as you?",
					"Have you done any drugs?","If you were forced to kill someone, who would it be?",
					"Tell us a secret","Do you have any bad habits?","What would you like to know if you could know anything about your future?",
					"How good-looking do you think you are from a scale 1-10?","Do you want to have kids?","What was the peak this month?",
					"Have you ever done something you regret?","How much money do you make a month?","Are you in love with someone?",
					"Give 3 good advices for the evening","How do you think your friends perceive you?","How do you think your frinds perceive you when you are drunk?",
					"When was last time you lied about something?","What is the most unnecessary you have bought?",
					"What is the worst pick up line you have ever heard?","Do you have any strategy for tonight?","Do you have any free-passes?",
					"Have you ever been to jail for being to drunk?","When did you puke last time?","Let the other players ask you something"]

		nicedare = ["Sing your favourite song","Stand up and hold a short speech for the group","Call a pizza place and ask for a birthday cake",
					"Sing a Justin Bieber song","Find an object and try to sell it to the group","Pretend to be a cheerleader and dance and sing",
					"Impress everyone by doing a cool trick","Pretend to be a wizard for the next 10 minutes","Call someone and sound like a horse","Flirt with someone in the group",
					"Tell a ghost story","Put on a good song and do a performance no one will forget","Drink up what is left in your glass","Post a Facebook status update about unicorns",
					"Spin around 25 times", "Write YOLO with help of your friends bodies and post on a social network","Eat something from the kitchen",
					"Change someones hairstyle","Let someone take a photo of you and use it to change your profile picture on facebook and keep it for at least an hour."]
		
		alltruth = nicetruth.concat(eviltruth);

		alldare = nicedare.concat(evildare);

	}


	this.initialize();

};

var gametodhtml = Handlebars.compile($('#gametod').html());
var todsettings2 = Handlebars.compile($('#todsettings2').html());
var todwaitstart = Handlebars.compile($('#todwaitstart').html());
var todstartround = Handlebars.compile($('#todstartround').html());
var todendgame = Handlebars.compile($('#todendgame').html());


var entodplayers = [];

var alltruth;
var alldare;
var nicedare;
var nicetruth;
var evildare;
var eviltruth;

var entodplayer;