var svGametod = function() {
	
	this.initialize = function() {
		var self = this;
		this.el = $('<div/>');
		todplayers.length = 0;
		$.jStorage.deleteKey("latestplayer");
		self.registerEvents();
	},
	
	this.render = function() {
		this.el.html(svgametodhtml);
        return this;
	},

	this.registerEvents = function() {
		var self = this;
		var rounds = 10;
		var evil = 0;
		this.el.on("click", "#nexttod", function() {
			if (todplayers.length > 0) {
				$('.todcontentwrapper').html(svtodsettings2);
			}
			else {
				app.showAlert("Du måste lägga till spelare!")
			}
		});
		this.el.on("click", "#starttod", function() {
			$.jStorage.set("evil", evil);
			self.newGame(rounds);
		});
		this.el.on("click", ".endround", function() {
			var round = $.jStorage.get("round");
			var rounds = $.jStorage.get("rounds");
			round++;
			if (round == rounds) {
				self.endGame();
			} else {
				self.waitStart();
			}
		});
		this.el.on("click", ".todaddplayer", function() {
			var player = $('.todplayers').val();
			if (player.length > 0) {
				todplayers.push({ player: player });
				$('.todplaying').append("<li class=\"teamslist\"><small>" + player + "</small></li>")
				$('.todplayers').val("");
				$('.todplayers').attr("placeholder", "Lägg till fler..");
			} else {
				app.showAlert("Du måste skriva in ett namn först!");
			}
		});
		this.el.on("keypress", ".todplayers", function(event) {
        	var player = $('.todplayers').val();
        	var p = event.which;
        	if (p == 13) { 
        		event.preventDefault();
        		if (player.length > 0) {
					todplayers.push({ player: player });
					$('.todplaying').append("<li class=\"teamslist\"><small>" + player + "</small></li>")
					$('.todplayers').val("");
					$('.todplayers').attr("placeholder", "Lägg till fler..");
				} else {
					app.showAlert("Du måste skriva in ett namn först!");
				}
        	}
        	return;
        });
		this.el.on("click", ".cr5", function() {
			rounds = 10;
			$('.selectrounds').text("10");
		});
		this.el.on("click", ".cr10", function() {
			rounds = 20;
			$('.selectrounds').text("20");
		});
		this.el.on("click", ".cr15", function() {
			rounds = 30;
			$('.selectrounds').text("30");
		});
		this.el.on("click", ".cr30", function() {
			rounds = 50;
			$('.selectrounds').text("50");
		});
		this.el.on("click", ".todnice", function() {
			evil = 0;
			$('.selectdifficulty').text("Snälla");
		});
		this.el.on("click", ".todevil", function() {
			evil = 1;
			$('.selectdifficulty').text("Elaka");
		});
		this.el.on("click", ".todall", function() {
			evil = 2;
			$('.selectdifficulty').text("Alla");
		});
		self.el.on('click', '#starttruth', function() {
			var dare = false;
			self.startRound(todcurrentplayer, dare);
		});
		self.el.on('click', '#startdare', function() {
			var dare = true;
			self.startRound(todcurrentplayer, dare);
		});
		self.el.on('click', '.playagain', function() {
			self.playAgain();
		});
	},

	this.playAgain = function() {
		var self = this;
		var rounds = $.jStorage.get("rounds");
		clearInterval(countdown);
		self.newGame(rounds);
	}

	this.waitStart = function() {
		var self = this;
		var round = $.jStorage.get("round");
		var rounds = $.jStorage.get("rounds");
		var latestplayer = $.jStorage.get("latestplayer");
		if (round == rounds) {
			self.endGame();
		}
		else {
			round++;
			$.jStorage.set("round", round);
			var playernm = parseFloat(todplayers.length);
			//console.log(playernm);
			$('.todcontentwrapper').html(svtodwaitstart);
			var p1 = 1;
			//console.log(latestplayer);
			if (latestplayer >= playernm) {
				//console.log("reset");
				p1 = 1;
				$.jStorage.set("latestplayer", p1);
			}
			else {
				//console.log("add one");
				latestplayer++;
				p1 = latestplayer;
				$.jStorage.set("latestplayer", p1);
			}
			//var p1 = Math.floor(Math.random()*playernm);
			p1--;
			//console.log(p1);
			todcurrentplayer = todplayers[p1].player;
			//console.log(player);
			$('.playername').append("Nästa spelare är <b>" + todcurrentplayer + ".</b> \n Sanning eller Konsekvens?");
		}

	}

	this.endGame = function() {
		$.jStorage.deleteKey("round");
		app.hasPlayedGame();
		$('.todcontentwrapper').html(svtodendgame);
	}

	this.startRound = function(todcurrentplayer, dare) {
		var self = this;
		var round = $.jStorage.get("round");
		var rounds = $.jStorage.get("rounds");
		if (round == rounds) {
			self.endGame();
			return;
		} else {
			$('.todcontentwrapper').html(svtodstartround);
			if (dare) {
				var todtodo = self.getDare();
				$('.todinstructions').html("<b>" + todcurrentplayer + "</b>: <br> " + todtodo);		
			}
			else if (!dare) {
				var todtodo = self.getTruth();
				//console.log(todtodo)
				$('.todinstructions').html("<b>" + todcurrentplayer + "</b>: <br> " + todtodo);	
			}
		}
		return;
	}

	this.newGame = function(rounds) {
		var self = this;
		var rounds = parseFloat(rounds);
		rounds++;
		$.jStorage.set("rounds", rounds);
		$.jStorage.set("round", 0);
		$('#starttod').detach();
		self.populateContent();
		self.waitStart();
	},

	this.getDare = function() {
		var evil = parseFloat($.jStorage.get("evil"));
        if (evil == 0) {
        	var length = nicedare.length;
        	var generatedid = Math.floor(Math.random()*length);
	        var dare = nicedare.splice(generatedid, 1);
	        return dare;
        } else if (evil == 1) {
        	var length = evildare.length;
        	var generatedid = Math.floor(Math.random()*length);
	        var dare = evildare.splice(generatedid, 1);
	        return dare;     	
        } else if (evil == 2) {
        	var length = alldare.length;
        	var generatedid = Math.floor(Math.random()*length);
	        var dare = alldare.splice(generatedid, 1);
	        return dare;
        } else {
        	return;
        }
	},

	this.getTruth = function() {
		var evil = parseFloat($.jStorage.get("evil"));
        if (evil == 0) {
        	var length = nicetruth.length;
      		//console.log(length);
        	var generatedid = Math.floor(Math.random()*length);
        	//console.log(generatedid);
	        var truth = nicetruth.splice(generatedid, 1);
	        return truth;
        } else if (evil == 1) {
      		var length = eviltruth.length;
      		//console.log(length);
        	var generatedid = Math.floor(Math.random()*length);
        	//console.log(generatedid);
	        var truth = eviltruth.splice(generatedid, 1);
	        return truth;   	
        } else if (evil == 2) {
        	var length = alltruth.length;
        	var generatedid = Math.floor(Math.random()*length);
	        var truth = alltruth.splice(generatedid, 1);
	        return truth;
        } else {
        	return;
        }
	},

	this.populateContent = function() {

		eviltruth = ["Hur förlorade du din oskuld?","Hur många har du haft sex med?","Vad är det roligast stället du haft sex på?",
					"Vilket är ditt värsta sexminne?","Har du kollat på porr någon gång?","Vilken är din favorit sexställnig?",
					"Vem skulle du välja om du fick ha sex med vem du ville?","Har du nånsin blivit påkommen när du haft sex?",
					"Har du nångsin kommit på din partner med att onanera?","Äger du någon sexleksak?","Skulle du kunna göra något sexuellt med någon från ditt jobb?",
					"Har du nångsin gjort något sexuellt med någon av samma kön?","Har du haft någon sexdröm om någon opassande?",
					"Om du var tvungen att ligga med någon av Harry Potter-karaktärerna, vem skulle du välja??","Vad är det dummaste du gjort när du varit full?",
					"Har du varit otrogen någon gång?","När var du full för första gången?","Vilken är den största ålderskillnaden på någon du legat med?",
					"Har du någonsin haft en sexfantasi om någon i en kompis familj?","Ångrar du något av dina ligg?","Har du legat med någon som var i ett förhållande?",
					"Har du någon favoritlåt att ha sex till?","Har du haft sex med någon du tycker är ful?","Vem hade du sex med senast?",
					"Vem hånglade du med senast","Vem tror du har störst snopp här inne?","Har du haft gruppsex?","Har du någon fetish?",
					"Vad är det roligaste du hört när någon försökt ragga upp dig?","Vilken är dem sämsta raggningsrepliken någon sagt till dig?",
					"Tycker du att storleken spelar någon roll?","Har du haft sex på någon offentlig plats?","Berätta ett roligt sexminne",
					"Vad är det pinsammaste som hänt dig när du haft sex?","När onanerade du senast?","När spydde du senast?",
					"Brukar du bli för full när du är ute?","Hur tror du att dina vänner skulle beskriva dig som full?","När hade du minnesluckor senast?",
					"Brukar du ha någon strategi när du går ut på krogen?","När gjorde du bort dig senast?","Hur snygg tycker du att du är på en skala 1-10?",
					"Har du några krav på en partner?","Hemma eller bortamatch?","Brukar du drömma sexdrömmar?","Har du något frikort?",
					"Har du varit gravid någon gång?","Har du haft oskyddat sex?","Har du sett någon annan ha sex?","Vilket är det mest impulsiva ligget du haft?",
					"Brukar du ringa booty calls? Till vem i så fall?","Vilka brukar du oftast få fylle-sms ifrån?","Har du suttit i fyllecell?",
					"Vem brukar bli fullast på fester?","Har du någon dålig ovana som du gör när du druckit?","Vad dricker du helst?",
					"Gillar du när det låter när du har sex?","Hade du kunnat ha sex på TV?","Hade du kunnat tänka dig att vara med i Paradise Hotel?",
					"Vad tänder du på hos en partner?","Vilken är den värsta sexhistorien någon berättat för dig?","Vilken är den roligast sexhistorien någon berättat för dig?",
					"Har du haft någon könssjukdom?","Vem är den bästa och sämsta du haft sex med?","Har du några dolda piercingar/ tatueringar?",
					"Berätta om ett misslyckat raggningsförsök","Vad är det olagligaste du gjort?","Har du testat några droger?",
					"Finns det något som du ångrar riktigt mycket?","Har du haft sexfantasier om en lärare?","Ge ett bra sextips",
					"Har du haft telefonsex?","Hur mycket pengar tjänar du i månaden?","Vilket politiskt parti röstar du på?",
					"Har du gjort någon skönhetsoperation?","Har du kört rattfull?"]

		evildare = ["Dansa till en låt av Miley Cyrus och twerka","Dansa till Gagnam Style-låten","Ta av dig din BH (Om du har någon på)",
					"Byt kläder med någon","Smiska någon","Skicka ett sexigt SMS till någon","Slicka på någon av de andra",
					"Prata i klyshor resten av kvällen","Ge någon en lapdance","Dansa och sjung till Im sexy and i know it av LMFAO",
					"Låtsas att du föder barn","Ring någon och sjung Ops i did it again av Britney Spears","Låtsas vara en kåt apa tills det är din tur igen",
					"Låt någon vara din häst och rid ett varv runt rummet","Ge någon en kyss","Gör doggy style med valfri deltagare",
					"Drick upp det som är kvar i ditt glas","Dra en grym raggningsreplik och flirta med någon","Sminka någon som en strippa",
					"Jucka som en hund på valfri deltagares ben","Låtsas att du får en orgasm",
					"Låt någon skicka ett SMS från din telefon","Gör en body shot","Hångla med någon","Ge någon massage","Bjud upp någon till dans",
					"Fråga de andra deltagarna något","Ge alla deltagare en komplimang","Visa hur atletisk du är","Känn på någons bröst",
					"Knacka på grannen och fråga något dumt","Busring till någon","Öppna fönstret och skrik som Tarzan","Sätt på en bra låt och veva som en stekare",
					"Stå på händer","Gör en kullerbytta","Snurra runt 30 gånger","Spela luftgitarr och sjung Smoke on the Water",
					"Surpla överdrivet mycket när du dricker nästa runda","Prata porrigt från och med nu och en kvart fram",
					"Utmana någon i armbrytning","Ring någon och fråga vad som egentligen hände igår","Lägg upp en status på Facebook och fråga vem som glömde sin menskopp hos dig igår",
					"Skicka en vänförfrågan till ett gammalt ex på Facebook","Skicka en vänförfrågan till en lärare du haft på Facebook",
					"Skicka ett SMS och skriv Sugen? till någon","Skicka en förfrågan om förhållande till en gammal flört på Facebook","Skriv något porrigt till någon av dina vänner på Facebook"]

		nicetruth = ["Vad handlade din senaste dröm om?","Vad är det pinsammaste du gjort?","Har du snattat någon gång?",
					"Vad heter din första kärlek?","Vem är din förebild?","Vem skulle du vara om du fick vara någon annan för en dag?",
					"Vad skulle du göra om du fick vara osynlig för en dag?","Om du var en karaktär i Harry Potter, vem skulle du vara?",
					"Har du någon kändiscrush?","Om du bara fick använda ett ord resten av kvällen, vilket skulle du välja?",
					"Tror du på spöken?","Om du kunde resa vart du ville, vart skulle du åka?",
					"Vilket TV-program skulle du helst vilja vara med i?",
					"Vem skulle du vara om du var en karaktär i en TV-serie?","Säg en bra raggningsreplik!",
					"När hade du minnesluckor sist?","Berätta om första gången du var full",
					"Vad är det roligaste du gjort när du var full?","Berätta något roligt om någon i gruppen",
					"Vad ville du bli när du var liten?","Har du någon fobi?","Har du någon dold talang?","Vad är du mest nöjd med på din kropp?",
					"Berätta om första gången du träffade alla i gruppen, första intryck osv","Sälj in personen till höger om dig till gruppen",
					"Om du fick tre önskningar, vad skulle du önska?","Om du blev återfödd som ett djur, vilket tror du att du skulle vara?",
					"Vem irriterade dig senast?","Vad skulle du heta om du var en porrstjärna?","Dela med dig av ett bra tips",
					"Berätta något oväntat","Berätta om din första kyss","Vem är ditt snyggaste hångel?","Ditt yngsta respektive äldsta hångel?",
					"Har du hånglat med fler än en person under en 24-timmarsperiod?","Nämn en detalj i andras utseende som attraherar dig?",
					"Vilken är den pinsammaste skivan du äger?","Har du ljugit för att få nån i säng, och i så fall vad sa du?",
					"Har du varit intresserad av någon av samma kön?","Har du provat någon drog?","Om du var tvungen att döda någon, vem skulle du välja?",
					"Berätta en hemlighet","Berätta om en dålig ovana du har?","Du är en känd artist på turne, vad kräver du att det finns i din loge?",
					"Om du fick veta en sak om framtiden, vad skulle du vilja veta?","På en skala 1-10, hur snygg tycker du att du är?",
					"Vill du ha barn?","Vad var månadens höjdpunkt?","Vad är det mesta du har vunnit?","Har du tagit springnota någon gång?",
					"Har du gjort något du ångrar?","Hur mycket pengar tjänar du i månaden?","Vilket politiskt parti röstar du på?",
					"Vad ljög du senast om?","Vad är det onödigaste du köpt?","Är du kär i någon?","Vilken är den sämsta raggningsrepliken du hört?",
					"Vad är det roligaste någon sagt till dig när den försökt ragga upp dig?","Har du någon strategi för kvällen?",
					"Vilken dokusåpa skulle du helst vara med i?","Har du något frikort?","Ge de andra tre bra tips för kvällen",
					"Hur tror du dina vänner uppfattar dig?","Hur tror du dina vänner tycker att du är när du är full?",
					"Har du suttit i fyllecell?","När spydde du senast?","Har du varit intresserad av någon på ditt jobb?",
					"Har du gjort något sexuellt med någon du är släkt med?","Hemma eller bortamatch?","Har du nånsin lagt en oläglig fis?",
					"Känner dina föräldrar dig som dina vänner gör?","Berätta ett bra raggningstips","Vad dricker du helst?"]

		nicedare = ["Sing your favourite song","Ställ dig upp och håll ett tal","Ring en pizzeria och fråga om du kan få sushi på pizzan",
					"Sjung en Justin Bieber låt","Låtsas vara en cheerleader och gör en hejarramsa (dans ger pluspoäng)","Hitta något coolt och försök sälja det till någon i gruppen",
					"Imponera genom att göra ett coolt trick","Låtsas att du är en trollkarl de nästkommande 10 minuterna","Ring någon och låt som valfritt djur",
					"Flirta med någon i gruppen","Berätta en spökhistoria","Sätt på en bra låt och bjud på ett uppträdande ingen kommer att glömma",
					"Drick upp det som är kvar i ditt glas","Gör en statusuppdatering på Facebook om enhörningar","Snurra runt 25 gånger",
					"Skriv YOLO med hjälp av kroppar och föremål i rummer och ta en bild och lägg upp på Facebook/Instagram","Ät något från kylskåpet",
					"Ändra någons frisyr","Låtsas vara en cirkusstjärna och gör ett uppträdande","Knacka på en granne och fråga om du får låna lite mjöl",
					"Busring till någon","Prata engelska de kommande 15 minuterna","Visa lite fräcka danssteg","Gör en kullerbytta",
					"Ge någon massage","Uppträd till en Vengaboys-låt","Välj en person som ska vara med dig och uppträda till en Dr Bombay-låt",
					"Personen till höger om dig bestämmer vad du ska göra","Personen till vänster om dig ger dig ett uppdrag",
					"Låtsas att du är en finsmakare när du dricker de nästkommande 10 minuterna","Tala på rim fram tills du får nästa fråga",
					"Tala i klyschor resten av kvällen","Måla naglarna på dig själv eller någon annan","Stå upp och sjung nationalsången med handen på hjärtat",
					"Bjud upp någon till dans",
					"Fråga de andra deltagarna något","Ge alla deltagare en komplimang","Visa hur atletisk du är",
					"Knacka på grannen och fråga något dumt","Busring till någon","Öppna fönstret och skrik som Tarzan","Sätt på en bra låt och veva som en stekare",
					"Stå på händer","Gör en kullerbytta","Snurra runt 30 gånger","Spela luftgitarr och sjung Smoke on the Water",
					"Surpla överdrivet mycket när du dricker nästa runda","Prata porrigt från och med nu och en kvart fram",
					"Utmana någon i armbrytning","Ring någon och fråga vad som egentligen hände igår","Lägg upp en status på Facebook och fråga om någon vet skillnaden på ris och couscous",
					"Skicka en vänförfrågan till ett gammalt ex på Facebook","Skicka en vänförfrågan till en lärare du haft på Facebook",
					"Skicka ett SMS och skriv Sugen? till någon","Skriv en klychig statusuppdatering på Facebook","Skriv ett tråkigt skämt till någon av dina vänner på Facebook"]

		alltruth = nicetruth.concat(eviltruth);

		alldare = nicedare.concat(evildare);

	}



	this.initialize();

};

var svgametodhtml = Handlebars.compile($('#svgametod').html());
var svtodsettings2 = Handlebars.compile($('#svtodsettings2').html());
var svtodwaitstart = Handlebars.compile($('#svtodwaitstart').html());
var svtodstartround = Handlebars.compile($('#svtodstartround').html());
var svtodendgame = Handlebars.compile($('#svtodendgame').html());


var todplayers = [];


var alltruth;
var alldare;
var nicedare;
var nicetruth;
var evildare;
var eviltruth;

var todcurrentplayer;